-- ConsoleHelper
-- #18121522
-- 
-- BigBlueHH 
-- 
local version = "1.0.0.0 (15.12.2018)";

ConsoleHelper = {};

addConsoleCommand("chT", "print a table recursively", "chT", ConsoleHelper);
function ConsoleHelper:chT(str, value)
	t = ConsoleHelper:stringToTable(str);
	n = 1;
	if not ConsoleHelper:isEmpty(value) then
		n = tonumber(value);
	end;
	print ("### chT ### BEGIN ### Table: "..str);
	DebugUtil.printTableRecursively(t,".",0,n);
	print ("### chT ### END ### Table: "..str);
end;

addConsoleCommand("chF", "call a function/method", "chF", ConsoleHelper);
function ConsoleHelper:chF(str, arg1, arg2, arg3)
	print("### chF ### BEGIN");
	if not ConsoleHelper:isEmpty(str) and not ConsoleHelper:isEmpty(arg1) and not ConsoleHelper:isEmpty(arg2) and not ConsoleHelper:isEmpty(arg3) then
		print("Call: "..str.."("..arg1..", "..arg2..", "..arg3..")");
		print(assert(loadstring('return '..str..'(...)'))(arg1,arg2,arg3));
	elseif not ConsoleHelper:isEmpty(str) and not ConsoleHelper:isEmpty(arg1) and not ConsoleHelper:isEmpty(arg2) then
		print("Call: "..str.."("..arg1..", "..arg2..")");
		print(assert(loadstring('return '..str..'(...)'))(arg1,arg2));
	elseif not ConsoleHelper:isEmpty(str) and not ConsoleHelper:isEmpty(arg1) then
		print("Call: "..str.."("..arg1..")");
		print(assert(loadstring('return '..str..'(...)'))(arg1));
	elseif not ConsoleHelper:isEmpty(str) then
		print("Call: "..str.."()");
		print(assert(loadstring('return '..str..'(...)'))());		
	else
		print ("toDo show example");
	end;
	print("### chF ### END");
end;

addConsoleCommand("chV", "get/set field value", "chV", ConsoleHelper);
function ConsoleHelper:chV(str, arg1)
	print("### chV ### BEGIN");
	if not ConsoleHelper:isEmpty(str) and not ConsoleHelper:isEmpty(arg1) then
		print("Name: "..str);
		print("Old Value: "..ConsoleHelper:stringToTable(str)); 
		t = getfenv(0);
		for w, d in string.gfind(str, "([%w_]+)(.?)") do
			if d == "." then
			  t = t[w];
			else	  
				if tonumber(arg1) ~= nil then
					t[w] = tonumber(arg1);
				else
					t[w] = arg1;
				end;			  
			end;
		end;
		print("New Value: "..ConsoleHelper:stringToTable(str));
	elseif not ConsoleHelper:isEmpty(str) then
		print("Name : "..str);
		print("Value: "..ConsoleHelper:stringToTable(str));
	else
		print ("toDo show example");
	end;
	print("### chV ### END");
end;

function ConsoleHelper:stringToTable(str)
	local levels = StringUtil.splitString(".", str);
	local levelsDepth = table.getn(levels);
	local tmpTable = getfenv(0);
	local result;
	--print ("LevelsDepth: "..tostring(levelsDepth))
	if levels ~= nil and levelsDepth > 0 then
		for k,v in pairs(levels) do
			--print(tostring(k).."="..type(k).." ; "..tostring(v).."="..type(v))
			if tonumber(v) ~= nil then
				tmpTable = tmpTable[tonumber(v)];
			else
				tmpTable = tmpTable[tostring(v)];
			end;
		end;
		result = tmpTable;
	else
		print("something went wrong");
	end;
	return result;
end;

function ConsoleHelper:isEmpty(s)
  return s == nil or s == '';
end

function ConsoleHelper:loadMap() end;
function ConsoleHelper:loadSavegame() end;
function ConsoleHelper:saveSavegame() end;
function ConsoleHelper:update(dt) end;
function ConsoleHelper:mouseEvent(posX, posY, isDown, isUp, button) end;
function ConsoleHelper:keyEvent(unicode, sym, modifier, isDown) end;
function ConsoleHelper:draw() end;
function ConsoleHelper:delete()end;
function ConsoleHelper:deleteMap() end;